#include <gtk/gtk.h>
#include <mysql/mysql.h>
#include "main.h"



void add_a_category(){
    GtkWidget *dialog;
    GtkWidget *hbox, *label, *entry;
    GtkTreeIter iter, iter2;
    int close  = 0;
    GString *query = g_string_new("");;

    if(mysql_handle == NULL) return;
    
    dialog = gtk_dialog_new_with_buttons("Add a Category", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_ADD, GTK_RESPONSE_ACCEPT,
		"Add and Close", GTK_RESPONSE_YES,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);


    hbox = gtk_hbox_new(FALSE, 6);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
    label = gtk_label_new("Category name:");
    entry = gtk_entry_new_with_max_length(128); /* category is only 128 char's */
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), hbox);
    
    gtk_widget_show_all(hbox);
    while(!close){
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_YES:
		close = 1;
	case GTK_RESPONSE_ACCEPT:
	    if(strlen(gtk_entry_get_text(GTK_ENTRY(entry))) == 0) break;
		g_string_printf (query, "CREATE TABLE `%s` ( `items` VARCHAR(255) NULL)", gtk_entry_get_text(GTK_ENTRY(entry)));
	        if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    close = 0;
		    break;
		}	
		g_string_printf (query, "INSERT INTO `dbase` VALUES (\"%s\")", gtk_entry_get_text(GTK_ENTRY(entry)));
		if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    g_string_printf(query, "DROP TABLE `%s`", gtk_entry_get_text(GTK_ENTRY(entry)));
		    mysql_query(mysql_handle,  query->str);
		    close = 0;
		    break;
		}
	gtk_tree_store_insert(main_win.index.treestore, &iter, NULL, 0);
	gtk_tree_store_set(main_win.index.treestore, &iter, 0, gtk_entry_get_text(GTK_ENTRY(entry)), 1,0, -1);
	gtk_tree_store_append(main_win.index.treestore, &iter2, &iter);
	gtk_tree_store_set(main_win.index.treestore, &iter2, 0, "<add sub-category>", 1,3, -1);
	gtk_entry_set_text(GTK_ENTRY(entry), "");
	break;		
	case GTK_RESPONSE_CANCEL:
	    close = 1;
	    break;
	default: break;
    	}
    }
    gtk_widget_destroy(dialog);
    g_string_free(query, TRUE);
    return;
    }


void delete_a_category(){
    GtkWidget *dialog;
//    char query[1024];

    GtkTreeSelection *selection;
    GtkTreeIter iter;
    gchar *name;
    int value;
    GString *query = g_string_new("");
    
    if(mysql_handle == NULL) return;
    
    /* check if there is a selection if yes then check if double clicked on add category */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    if(gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter))
	{
	    gtk_tree_model_get(main_win.index.model, &iter, 0, &name,1, &value, -1);
	}
    else value =1;
    
    if(value != 0){
    dialog = gtk_message_dialog_new(GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_WARNING,
		GTK_BUTTONS_CLOSE,
		"Please select an Category in the index list");
    gtk_dialog_run(GTK_DIALOG(dialog));
    gtk_widget_destroy(dialog);
    g_string_free(query, TRUE);
    return;
    }    
    

    
    dialog = gtk_message_dialog_new(GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_WARNING,
		GTK_BUTTONS_OK_CANCEL,
		"Are you sure you want to delete the category \"%s\"\nand all it's sub-category's?", name);

    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_OK:
	    {
	    MYSQL_ROW mysql_row;
	    MYSQL_RES *mysql_result;
	    g_string_printf(query, "select * from `%s`", name);
	    if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		
		    break;
		}
	    if((mysql_result = mysql_use_result (mysql_handle)) == NULL)
		{
		    error_dialog(mysql_error(mysql_handle));
		    break;
		}
	    /* drop main table and all next tables */
    	    g_string_printf(query, "drop table `%s`", name);
	    while((mysql_row = mysql_fetch_row(mysql_result))) 
		g_string_append_printf(query, ",`%s`", mysql_row[0]);
	    mysql_free_result(mysql_result);

	    mysql_query (mysql_handle, query->str);

	    g_string_printf (query, "DELETE FROM dbase WHERE type=\"%s\"", name);
	    if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    break;
		}
	    load_index_tree();
	    }
	case GTK_RESPONSE_CANCEL:
	default: break;
    	}
    gtk_widget_destroy(dialog);
    g_string_free(query, TRUE);
    return;
}


void edit_category_title(){
    GtkTreeSelection *selection;
    GtkWidget *dialog;
    GtkWidget *hbox, *label, *entry;
    GtkTreeIter iter2;
    int close  = 0;
    GString *query = g_string_new("");
    gchar *name;
    
    if(mysql_handle == NULL) return;
    
    dialog = gtk_dialog_new_with_buttons("Edit Category title", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_APPLY, GTK_RESPONSE_ACCEPT,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);


    hbox = gtk_hbox_new(FALSE, 6);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
    label = gtk_label_new("Category name:");
    entry = gtk_entry_new_with_max_length(128); /* category is only 128 char's */
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), hbox);
    
    
    /* get the category name */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
    gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);

    gtk_entry_set_text(GTK_ENTRY(entry), name);
    
    gtk_widget_show_all(hbox);

    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_YES:
		close = 1;
	case GTK_RESPONSE_ACCEPT:
	    if(strlen(gtk_entry_get_text(GTK_ENTRY(entry))) == 0) break;
		g_string_printf (query, "ALTER TABLE `%s` RENAME `%s`", name, gtk_entry_get_text(GTK_ENTRY(entry)));
	        if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    close = 0;
		    break;
		}	
		g_string_printf (query, "UPDATE `dbase`  set `type`=\"%s\" WHERE `type`=\'%s\' LIMIT 1", gtk_entry_get_text(GTK_ENTRY(entry)), name);
		if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    g_string_printf(query, "TABLE `%s` RENAME `%s`", gtk_entry_get_text(GTK_ENTRY(entry)), name);
		    mysql_query(mysql_handle,  query->str);
		    close = 0;
		    break;
		}
	gtk_tree_store_set(main_win.index.treestore, &iter2, 0, gtk_entry_get_text(GTK_ENTRY(entry)), 1,0, -1);
	break;		
	case GTK_RESPONSE_CANCEL:
	    break;
	default: break;
    	}
    gtk_widget_destroy(dialog);
    g_string_free(query, TRUE);
    return;
    }

