#include <gtk/gtk.h>
#include <mysql/mysql.h>
#include "main.h"

void edit_view_a_item(){
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    int value = 0, i, close = 0, curr  = 1, nsel;
    GtkWidget *dialog;
    GtkWidget **entries;
    GtkWidget **labels;
    GtkWidget *table;
    gchar *name, *tname;
    GString *query;
    GList *list, *here;
    if(mysql_handle == NULL) return;

    
    /* check if there is a selection if yes then check if double clicked on add category */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    if(gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)){
	gtk_tree_model_get(main_win.index.model, &iter, 0, &tname, 1, &value, -1);
	}
    if(value != 1)
	{
	error_dialog("You can only view an item in a Sub-Category");	
	return;
	}
    if(ncol < 2){
	error_dialog("There is nothing usefull to edit or view here");	
	return;
    }


    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.table.treeview));
    if((nsel = gtk_tree_selection_count_selected_rows(selection)) == 0){
	error_dialog("You need to select 1 item (no more, no less) to view or edit it");
	return;
    }
    list = gtk_tree_selection_get_selected_rows(selection, &main_win.table.model);
    here = g_list_first(list);
    if(here == NULL ){
    error_dialog("something went wrong, sorry");
    return;
    }
    gtk_tree_model_get_iter(main_win.table.model, &iter, here->data);

    
    query = g_string_new("");
    
    entries = g_malloc((ncol-1)*sizeof(GtkWidget));
    for(i=0;i< ncol-1; i++){
     if(main_win.table.types[i+1] == G_TYPE_BOOLEAN){
       	gtk_tree_model_get(main_win.table.model, &iter, i+1, &value, -1);
        entries[i] = gtk_check_button_new();
	if(value) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entries[i]), TRUE);
       }
     else if(main_win.table.types[i+1] == G_TYPE_INT){
       	gtk_tree_model_get(main_win.table.model, &iter, i+1, &value, -1);
       entries[i] = gtk_spin_button_new_with_range(0,65535, 1);
       gtk_spin_button_set_value(GTK_SPIN_BUTTON(entries[i]), (double)value);
       }
     else{
     	gtk_tree_model_get(main_win.table.model, &iter, i+1, &name, -1);
      entries[i] = gtk_entry_new_with_max_length(255);
      gtk_entry_set_text(GTK_ENTRY(entries[i]), name);
      }
     }
    
    
    labels = g_malloc((ncol-1)*sizeof(GtkWidget));
    for(i=0;i< ncol-1; i++) labels[i] = gtk_label_new(gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i+1])));

    table = gtk_table_new(ncol+3, 4, FALSE);
    gtk_table_set_row_spacings(GTK_TABLE(table), 6);
    gtk_table_set_col_spacings(GTK_TABLE(table), 6);
    for(i=0; i< ncol -1; i++){
	gtk_table_attach(GTK_TABLE(table), labels[i], 0,1, i+1, i+2, GTK_FILL, GTK_FILL, 0,0);
	gtk_table_attach(GTK_TABLE(table), entries[i], 1,2, i+1, i+2, GTK_FILL, GTK_FILL, 0,0);
	if(i+1 < (ncol -1)){
	i++;
	gtk_table_attach(GTK_TABLE(table), labels[i], 2,3, i, i+1, GTK_FILL, GTK_FILL, 0,0);
	gtk_table_attach(GTK_TABLE(table), entries[i], 3,4, i, i+1, GTK_FILL, GTK_FILL, 0,0);
	}
    }

    dialog = gtk_dialog_new_with_buttons("View and Edit Item(s)", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_GO_BACK, GTK_RESPONSE_NO,
    		GTK_STOCK_GO_FORWARD, GTK_RESPONSE_ACCEPT,
    		GTK_STOCK_APPLY, GTK_RESPONSE_YES,
		GTK_STOCK_CLOSE, GTK_RESPONSE_CANCEL, 
		NULL);

    gtk_widget_show_all(table);
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), table);
    gtk_widget_show_all(GTK_DIALOG(dialog)->vbox);	
    i=0;
    while(!close){
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_NO:
	    if(curr == 1 || nsel == 1) break;
	    here = g_list_previous(here);
	    i = 1;
	    curr = curr -2;
	case GTK_RESPONSE_ACCEPT:
	if(curr == nsel) break;
	if(i == 0)here = g_list_next(here);
	gtk_tree_model_get_iter(main_win.table.model, &iter, here->data);
	for(i=0;i< ncol-1; i++){
    	    if(main_win.table.types[i+1] == G_TYPE_BOOLEAN)
		{
       		gtk_tree_model_get(main_win.table.model, &iter, i+1, &value, -1);
		if(value) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entries[i]), TRUE);
		else  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entries[i]), FALSE);
    		}
	else if(main_win.table.types[i+1] == G_TYPE_INT)
		{
       		gtk_tree_model_get(main_win.table.model, &iter, i+1, &value, -1);
    		gtk_spin_button_set_value(GTK_SPIN_BUTTON(entries[i]), (double)value);
    		}
	 else{
     		gtk_tree_model_get(main_win.table.model, &iter, i+1, &name, -1);
    		gtk_entry_set_text(GTK_ENTRY(entries[i]), name);
    		}
    	}
	curr++;
	i = 0;
	break;
	
	
	case GTK_RESPONSE_YES:
	    {
		gchar *name;
		GtkTreeSelection *selection;
		GtkTreeIter iter1;
		int i;
		selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
		gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter1); 
		gtk_tree_model_get(main_win.index.model, &iter1, 0, &name,  -1);
		g_string_printf (query, "UPDATE `%s` set ", name);
		for(i=0;i< ncol-1;i++)
		    {
			if(main_win.table.types[i+1] == G_TYPE_BOOLEAN){
			     g_string_append_printf(query, "`%s`=\"%i\"",gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i+1])), gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entries[i])));
			     gtk_list_store_set(main_win.table.liststore, &iter, i+1, gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entries[i])), -1);
			     }
			else if(main_win.table.types[i+1] == G_TYPE_INT){
			     g_string_append_printf(query, "`%s`=\"%i\"",gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i+1])), gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(entries[i])));
			     gtk_list_store_set(main_win.table.liststore, &iter, i+1, gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(entries[i])), -1);
			     }
			else { 
			    g_string_append_printf(query, "`%s`=\"%s\"",gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i+1])), gtk_entry_get_text(GTK_ENTRY(entries[i])));
			     gtk_list_store_set(main_win.table.liststore, &iter, i+1, gtk_entry_get_text(GTK_ENTRY(entries[i])), -1);
			    }
			if(i != (ncol-2)) g_string_append_printf(query, ", ");
		    } 
		    
		gtk_tree_model_get(main_win.table.model, &iter, 0, &i,  -1);
		g_string_append_printf(query, "where item=\"%i\"", i);
		/* add it to mysql */
		if(mysql_query(mysql_handle, query->str)){
		    error_dialog(mysql_error(mysql_handle));
		    close = 0;
		    break;	    
		}	
		
		 
		 i = 0;
		break;
	     }	
	case GTK_RESPONSE_CANCEL:
	    close = 1;
	    break;
	default: break;
    	}
    }

//    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	    
//    index_changed_test(selection);
    g_list_foreach (list, (GFunc)gtk_tree_path_free, NULL);
    g_list_free (list);
    gtk_widget_destroy(dialog);
    g_free(entries);
    g_free(labels);
    g_string_free(query, TRUE);
}
