#include <gtk/gtk.h>
#include <mysql/mysql.h>
#include "main.h"

void column_name_edited_string(GtkCellRendererText *cell, const char *path_string, const char *new_text, trees *as);
void change_sub_category_title(GtkWidget *button, GtkWidget *entry);
void edit_sub_category_add_but(GtkWidget *button, GtkListStore *list);
void edit_sub_category_remove_but(GtkWidget *button, trees *as);
int edit_sub_cat_type_string (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data);
int edit_sub_cat_type_int (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data);
int edit_sub_cat_type_bool (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data);


void edit_sub_category(){
    GtkWidget *dialog;
    GtkWidget *hbox, *label, *entry;
    GtkWidget *sw;
    GtkWidget *vbox, *add, *remove, *change;
    GtkCellRenderer *renderer;
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    gchar *name;
    trees *as;
    int i;
    
    if(mysql_handle == NULL) return;
    as = g_malloc(sizeof(trees));    
    dialog = gtk_dialog_new_with_buttons("Edit the current Sub-Category", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_CLOSE, GTK_RESPONSE_ACCEPT,
		NULL);
    gtk_widget_set_usize(GTK_WIDGET(dialog), 400, 400);
    hbox = gtk_hbox_new(FALSE, 6);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
    label = gtk_label_new("Sub-Category name:");
    entry = gtk_entry_new_with_max_length(255);
    change = gtk_button_new_with_label("Change");
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), change, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), hbox, FALSE, TRUE,0);

    hbox = gtk_hbox_new(FALSE, 6);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
    sw = gtk_scrolled_window_new(NULL, NULL);
    as->liststore = gtk_list_store_new(6, G_TYPE_INT,G_TYPE_STRING, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
    as->treeview = gtk_tree_view_new_with_model( GTK_TREE_MODEL(as->liststore));
    gtk_box_pack_start(GTK_BOX(hbox), sw, TRUE, TRUE, 0);    
    gtk_container_add(GTK_CONTAINER(sw), as->treeview);

    renderer = gtk_cell_renderer_text_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "Column name", renderer, "text",1, "editable", 5, NULL);
    g_signal_connect(G_OBJECT(renderer), "edited", G_CALLBACK(column_name_edited_string), as);


    renderer = gtk_cell_renderer_toggle_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "String", renderer, "active",2, NULL);
    g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(edit_sub_cat_type_string), GTK_TREE_MODEL(as->liststore));

    renderer = gtk_cell_renderer_toggle_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "Integer", renderer, "active",3, NULL);
    g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(edit_sub_cat_type_int), GTK_TREE_MODEL(as->liststore));

    renderer = gtk_cell_renderer_toggle_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "Boolean", renderer, "active",4, NULL);
    g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(edit_sub_cat_type_bool), GTK_TREE_MODEL(as->liststore));


    vbox = gtk_vbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, TRUE, 0);
    add = gtk_button_new_from_stock(GTK_STOCK_ADD);
    remove = gtk_button_new_from_stock(GTK_STOCK_DELETE);
    gtk_box_pack_start(GTK_BOX(vbox), add, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), remove, FALSE, TRUE, 0);

    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), hbox, TRUE, TRUE,0);        
    
    label = gtk_label_new("!!Warning!! All changes in the above list are directly applied");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, FALSE, TRUE, 0);
    gtk_widget_show_all(GTK_WIDGET(GTK_DIALOG(dialog)->vbox));
    
    /* signals */
    g_signal_connect(G_OBJECT(add), "clicked", G_CALLBACK(edit_sub_category_add_but), as->liststore);
    g_signal_connect(G_OBJECT(remove), "clicked", G_CALLBACK(edit_sub_category_remove_but), as);

    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    if(!gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)){
	error_dialog("Something went wrong, you shouldn't be here");
	return;
    }
    gtk_tree_model_get(main_win.index.model, &iter, 0, &name, -1);
    gtk_entry_set_text(GTK_ENTRY(entry), name);
    for(i=1; i<ncol;i++){
	gtk_list_store_append (as->liststore, &iter);
	if(main_win.table.types[i] == G_TYPE_STRING) gtk_list_store_set (as->liststore, &iter,0, i, 1, gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i])), 2,1,3,0,4,0,5,1, -1);
	else if(main_win.table.types[i] == G_TYPE_INT) gtk_list_store_set (as->liststore, &iter,0, i, 1, gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i])), 2,0,3,1,4,0,5,1, -1);
	else if(main_win.table.types[i] == G_TYPE_BOOLEAN) gtk_list_store_set (as->liststore, &iter,0, i, 1, gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i])), 2,0,3,0,4,1,5,1, -1);
	}    


    /* signals*/
    g_signal_connect(G_OBJECT(change), "clicked", G_CALLBACK(change_sub_category_title), entry);

    gtk_dialog_run(GTK_DIALOG(dialog));
    gtk_widget_destroy(dialog);
    g_free(as);
}

void change_sub_category_title(GtkWidget *button, GtkWidget *entry){
    GtkTreeSelection *selection;
    GtkTreeIter iter, parentiter;
    gchar *name, *name1;
    GString *query = g_string_new("");
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    if(!gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)){
	error_dialog("Something went wrong, you shouldn't be here");
	return;
    }
    gtk_tree_model_get(main_win.index.model, &iter, 0, &name, -1);
    g_string_printf(query, "ALTER TABLE `%s` RENAME `%s`", name, gtk_entry_get_text(GTK_ENTRY(entry)));
    if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	

    /* check if there is a selection if yes then check if double clicked on add category */
	    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter);
	    if(gtk_tree_path_get_depth(gtk_tree_model_get_path(main_win.index.model, &iter)) == 1){
		parentiter = iter;
		}
	    else{
		gtk_tree_model_get_iter_first(main_win.index.model, &parentiter);
		while(!gtk_tree_store_is_ancestor(main_win.index.treestore, &parentiter, &iter))
		{
		gtk_tree_model_iter_next(main_win.index.model, &parentiter);	
		}
	    }    
	    gtk_tree_model_get(main_win.index.model, &parentiter, 0, &name1, -1);


    g_string_printf(query, "UPDATE `%s` set `items`=\"%s\"  WHERE `items`=\'%s\' LIMIT 1", name1, gtk_entry_get_text(GTK_ENTRY(entry)), name);
    if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	

    gtk_tree_store_set(main_win.index.treestore, &iter, 0, gtk_entry_get_text(GTK_ENTRY(entry)), -1);
    g_string_free(query, TRUE);
}



void column_name_edited_string(GtkCellRendererText *cell, const char *path_string, const char *new_text, trees *as)
	{
	GtkTreeIter iter, iter2;
	char *name, *oldname;
	gint string, in, bo;
	GtkTreeSelection *selection;
    	GtkTreePath *path= gtk_tree_path_new_from_string(path_string);
	GString *query = g_string_new("");

	gtk_tree_model_get_iter (GTK_TREE_MODEL(as->liststore), &iter, path);
	gtk_tree_model_get(GTK_TREE_MODEL(as->liststore), &iter,1, &oldname,2, &string, 3, &in, 4, &bo,  -1);


	/* now also make the changes in mysql */
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
	gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
	gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);
	
	if(string == 1) g_string_printf(query, "ALTER TABLE `%s` CHANGE `%s` `%s` VARCHAR(255) DEFAULT NULL", name, oldname, new_text);
	else if(bo == 1) g_string_printf(query, "ALTER TABLE `%s` CHANGE `%s` `%s` TINYINT(1) DEFAULT NULL", name, oldname, new_text);
	else g_string_printf(query, "ALTER TABLE `%s` CHANGE `%s` `%s` int(255) DEFAULT NULL", name, oldname, new_text);
	if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
	gtk_list_store_set (as->liststore, &iter, 1, new_text, -1);
			    
    gtk_tree_path_free(path);
    g_string_free(query, TRUE);
    index_changed_test(selection);
    }


void edit_sub_category_add_but(GtkWidget *button, GtkListStore *list){
    GtkTreeIter iter;
    GtkTreeSelection *selection;
    int numr;
    gchar *name;
    GString *query = g_string_new("");
    
    
    numr = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(list), NULL);

    /* now also make the changes in mysql */
    /* get the table name */ /* I should store this something local.. I often query this.. well VERY often */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter); 
    gtk_tree_model_get(main_win.index.model, &iter,0, &name,  -1);


    g_string_printf(query, "ALTER TABLE `%s` ADD `<enter column name>` VARCHAR(255) NOT NULL ", name);
	if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
    

    gtk_list_store_append (list, &iter);
    gtk_list_store_set (list, &iter,0, numr+1, 1, "<enter column name>", 2,1,3,0,4,0,5,1, -1);
    
    g_string_free(query, TRUE);
    index_changed_test(selection);
    
}

void edit_sub_category_remove_but(GtkWidget *button, trees *as){
    GtkWidget *dialog;
    GtkTreeSelection *selection;
    GtkTreeIter iter, iter2;
    gchar *name, *cname;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(as->treeview));
    GString *query = g_string_new("");

    /* check if there is a selection, if so try to get the name of the column */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(as->treeview));
    if(!gtk_tree_selection_get_selected(selection, &model, &iter2)){
	error_dialog("You can't delete anything without selecting it first");	
	g_string_free(query, TRUE);
	return;
    }    
    gtk_tree_model_get(GTK_TREE_MODEL(as->liststore), &iter2,1, &cname,  -1);

    /* create a message dialog here */
    dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_YES_NO,
	    "Are you sure you want to delete the column:\n \"%s\" and all its information?", cname);
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_YES: 
		    break;
	default:
	    gtk_widget_destroy(dialog);
	    g_string_free(query, TRUE);
	    return;
	    }
    
    gtk_widget_destroy(dialog);
    
    /* get the table name */ /* I should store this something local.. I often query this.. well VERY often */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter); 
    gtk_tree_model_get(main_win.index.model, &iter,0, &name,  -1);

    g_string_printf(query, "ALTER TABLE `%s` DROP `%s`", name, cname);
	if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
    
    gtk_list_store_remove (as->liststore, &iter2);
    g_string_free(query, TRUE);
    index_changed_test(selection);
    
}

int
edit_sub_cat_type_string (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data)
  {
 GtkTreeModel *model = (GtkTreeModel *)data;
   GtkTreeIter  iter2, iter;
    GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
    gboolean fixed;
    GtkTreeSelection *selection;
    gchar *cname;
    gchar *name;
    GString *query = g_string_new("");
    
    /* get toggled iter */
    gtk_tree_model_get_iter (model, &iter, path);
    gtk_tree_model_get (model, &iter,1,&cname, 2, &fixed, -1);

    /* get the table name */ /* I should store this something local.. I often query this.. well VERY often */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
    gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);


    if(fixed == 1){ 
	    g_string_free(query, TRUE);
	    return 0;
	    }

    g_string_printf(query, "ALTER TABLE `%s` CHANGE `%s` `%s` VARCHAR(255) DEFAULT NULL", name, cname, cname);
    if(mysql_query(mysql_handle, query->str)){
    	    g_string_free(query, TRUE);
	    error_dialog(mysql_error(mysql_handle));
	    return 0;
	}	

   /* set new value */
     gtk_list_store_set (GTK_LIST_STORE (model), &iter, 2, TRUE, 3, FALSE, 4, FALSE, -1);
 
   /* clean up */
     gtk_tree_path_free (path);
     index_changed_test(selection);
     return 0;
 }



int edit_sub_cat_type_int (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data)
  {
 GtkTreeModel *model = (GtkTreeModel *)data;
   GtkTreeIter  iter2, iter;
    GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
    gboolean fixed;
    GtkTreeSelection *selection;
    gchar *cname;
    gchar *name;
    GtkWidget *dialog;
    GString *query = g_string_new("");
    
    /* get toggled iter */
    gtk_tree_model_get_iter (model, &iter, path);
    gtk_tree_model_get (model, &iter,1,&cname, 3, &fixed, -1);

    /* get the table name */ /* I should store this something local.. I often query this.. well VERY often */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
    gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);


    if(fixed == 1){ 
	    g_string_free(query, TRUE);
	    return 0;
	    }

    dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_YES_NO,
	    "Are you sure you want to change the column:\n \"%s\" to integer, you will probly loose information", name);
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_YES: 
		    break;
	default:
	    gtk_widget_destroy(dialog);
	    g_string_free(query, TRUE);
	    return 0;
	    }
    gtk_widget_destroy(dialog);


    g_string_printf(query, "ALTER TABLE `%s` CHANGE `%s` `%s` INT(255) DEFAULT NULL", name, cname, cname);
    if(mysql_query(mysql_handle, query->str)){
    	    g_string_free(query, TRUE);
	    error_dialog(mysql_error(mysql_handle));
	    return 0;
	}	

   /* set new value */
     gtk_list_store_set (GTK_LIST_STORE (model), &iter, 2, FALSE, 3, TRUE, 4, FALSE, -1);
 
   /* clean up */
     gtk_tree_path_free (path);
     index_changed_test(selection);
     return 0;
 }


int edit_sub_cat_type_bool (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data)
  {
 GtkTreeModel *model = (GtkTreeModel *)data;
   GtkTreeIter  iter2, iter;
    GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
    gboolean fixed;
    GtkTreeSelection *selection;
    gchar *cname;
    gchar *name;
    GtkWidget *dialog;
    GString *query = g_string_new("");
    
    /* get toggled iter */
    gtk_tree_model_get_iter (model, &iter, path);
    gtk_tree_model_get (model, &iter,1,&cname, 4, &fixed, -1);

    /* get the table name */ /* I should store this something local.. I often query this.. well VERY often */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
    gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);


    if(fixed == 1){ 
	    g_string_free(query, TRUE);
	    return 0;
	    }

    dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_YES_NO,
	    "Are you sure you want to change the column:\n \"%s\" to boolean, you will probly loose information", name);
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_YES: 
		    break;
	default:
	    gtk_widget_destroy(dialog);
	    g_string_free(query, TRUE);
	    return 0;
	    }
    gtk_widget_destroy(dialog);


    g_string_printf(query, "ALTER TABLE `%s` CHANGE `%s` `%s` TINYINT(1) DEFAULT NULL", name, cname, cname);
    if(mysql_query(mysql_handle, query->str)){
    	    g_string_free(query, TRUE);
	    error_dialog(mysql_error(mysql_handle));
	    return 0;
	}	

   /* set new value */
     gtk_list_store_set (GTK_LIST_STORE (model), &iter, 2, FALSE, 3, FALSE, 4, TRUE, -1);
 
   /* clean up */
     gtk_tree_path_free (path);
     index_changed_test(selection);
     return 0;
 }




void empty_sub_category(){
    GtkWidget *dialog;
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    gchar *name;
    GString *query = g_string_new("");

    /* get the table name */ /* I should store this something local.. I often query this.. well VERY often */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter); 
    gtk_tree_model_get(main_win.index.model, &iter,0, &name,  -1);

    /* create a message dialog here */
    dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_YES_NO,
	    "Are you sure you want to empty the whole sub-category: \"%s\"?", name);
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_YES: 
		    break;
	default:
	    gtk_widget_destroy(dialog);
	    g_string_free(query, TRUE);
	    return;
	    }
    gtk_widget_destroy(dialog);
    
    g_string_printf(query, "DELETE FROM `%s`", name);
    if(mysql_query(mysql_handle, query->str)){
    	    g_string_free(query, TRUE);
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
    
	
	    g_string_free(query, TRUE);
	    index_changed_test(selection);
    }
